from Products.PageTemplates.PageTemplate import PageTemplate
from TERRY import generate, syntax, config
from TERRY.interpreter import TERRYInterpreter
from Products.PageTemplates.Expressions import getEngine
from cStringIO import StringIO
import string, sys, pprint
import TextTools

class TextTemplate(PageTemplate):
    "Text Templates using TERRY, TAL, TALES, and METAL"
     
    content_type = 'text/plain'
    
    tt_edit = PageTemplate.pt_edit

    def TERRYseqs(self):
        """Get the currently configured sequences, initializing them if needed"""
        if not hasattr(self, 'TERRYstart'):
            self.TERRYstart = config.TERRYstart
        if not hasattr(self, 'TERRYend'):
            self.TERRYend = config.TERRYend
        if not hasattr(self, 'TERRYescape'):
            self.TERRYescape = config.TERRYescape
        return (self.TERRYstart, self.TERRYend, self.TERRYescape)

    def tt_render(self, source=0, extra_context={}):
        """Render this Text Template"""
        if self._v_errors:
            raise RuntimeError, 'Text Template %s has errors.' % self.id
        output = StringIO()
        c = self.pt_getContext()
        c.update(extra_context)
        if __debug__:
            __traceback_info__ = pprint.pformat(c)

        TERRYInterpreter(self._v_program, self._v_macros,
                       getEngine().getContext(c),
                       output,
                       tal=not source, strictinsert=0,
                       TERRYseqs=self.TERRYseqs())()
        return output.getvalue()

    pt_render = tt_render
    
    def read(self):
        if self._v_errors or not self.expand:
            return self._text
        try:
            return self.pt_render(source=1)
        except:
            self._v_errors = ('Macro expansion failed',
                                "%s: %s" % sys.exc_info()[:2])
            return self._text

    def tt_errors(self):
        if self._v_errors:
            return string.join(self._v_errors, '\n')

    def _cook(self):
        """Compile the TAL and METAL statments.

        A Text Template must always be cooked, and cooking must not
        fail due to user input.
        """
        table = syntax.table(self.TERRYstart, self.TERRYend, self.TERRYescape)
        table = TextTools.tag(self._text, table)[1]
        self._v_errors = ()
        try:
            gen = generate.generator(self._text, table)
            self._v_program, self._v_macros = gen.program, gen.macros
        except:
            self._v_errors = ["Compilation failed",
                              "%s: %s" % sys.exc_info()[:2]]
